/**
 * @license
 * Copyright (c) 2023 Handsoncode. All rights reserved.
 */
import { ProcedureAst } from '../../parser';
import { InterpreterState } from '../InterpreterState';
import { InterpreterValue } from '../InterpreterValue';
import { FunctionArgumentType, FunctionPlugin, FunctionPluginTypecheck } from './FunctionPlugin';
export declare class LogarithmPlugin extends FunctionPlugin implements FunctionPluginTypecheck<LogarithmPlugin> {
    static implementedFunctions: {
        LOG10: {
            method: string;
            parameters: {
                argumentType: FunctionArgumentType;
            }[];
        };
        LOG: {
            method: string;
            parameters: ({
                argumentType: FunctionArgumentType;
                greaterThan: number;
                defaultValue?: undefined;
            } | {
                argumentType: FunctionArgumentType;
                defaultValue: number;
                greaterThan: number;
            })[];
        };
        LN: {
            method: string;
            parameters: {
                argumentType: FunctionArgumentType;
            }[];
        };
    };
    log10(ast: ProcedureAst, state: InterpreterState): InterpreterValue;
    log(ast: ProcedureAst, state: InterpreterState): InterpreterValue;
    ln(ast: ProcedureAst, state: InterpreterState): InterpreterValue;
}
